import es
import cfglib
import popuplib
import gamethread
import playerlib

info = es.AddonInfo()
info['name'] = "Undead Buy"
info['basename'] = "undead_buy"
info['version'] = "1.2"
info['author'] = "Undead"
info['url'] = "http://forums.mattie.info/cs/forums/viewtopic.php?t=31590"
info['description'] = "Weapon/Item Buy Menu for Players"

es.ServerVar(info['basename'], info['version'], info['description']).makepublic()

itemList = {
  'glock': 400, 'usp': 500, 'p228': 600, 'deagle': 650,
  'fiveseven': 750,  'elite': 800, 'mac10': 1400, 'tmp': 1250,
  'mp5': 1500, 'ump': 1700, 'p90': 2350, 'm3': 1700,
  'xm1014': 3000, 'galil': 2000, 'famas': 2250, 'ak47': 2500,
  'm4a1': 3100, 'sg552': 3500, 'aug': 3500,  'm249': 5750,
  'scout': 2750, 'g3sg1': 5000, 'sg550': 4200, 'awp': 4750,
  'flashbang': 200, 'smokegrenade': 300, 'hegrenade': 300,
  'kevlar': 600, 'assaultsuit': 1000, 'nvgs': 1250, 'defuser': 200
}

cfg = cfglib.AddonCFG(es.getAddonPath('undead_buy') + '/config.cfg')
buy_cmd = cfg.cvar('ub_buy_cmd', '!buy', 'Commands to open Buy menu')
anywhere = cfg.cvar('ub_anywhere', '0', 'Allows access to menu anywhere on map. 1 = Yes & 0 = Only in Buy Zone.')
anytime = cfg.cvar('ub_anytime', '0', 'Allows access to menu anytime. 1 = Yes & 0 = Based of mp_buytime')
anyteam = cfg.cvar('ub_anyteam', '0', 'Allows which teams can use this. 0 = Both & 1 = Terrorist & 2 = CT')
nadelimit = cfg.cvar('ub_nadelimit', '0', 'How many grenades are allowed purchase of each kind. 0 = Unlimited')
for items in itemList:
  items = cfg.cvar('ub_%s'%items, itemList[items], 'Price for %s'%items)
cfg.write()

dictNades = {}
buyAllowed = False

def load():
  cfg.execute()
  if not es.exists('saycommand', buy_cmd):
    es.regsaycmd(buy_cmd, 'undead_buy/buy_cmd_reg')
  bmenu = popuplib.easymenu('bmenu', '_popup_choice', bmenu_select)
  bmenu.settitle("Buy Menu:")
  bmenu.addoption('1', "Pistols")
  bmenu.addoption('2', "Sub-Machine Guns")
  bmenu.addoption('3', "Shotguns")
  bmenu.addoption('4', "Rifles")
  bmenu.addoption('5', "Machine Guns")
  bmenu.addoption('6', "Sniper Rifles")
  bmenu.addoption('7', "Grenades")
  bmenu.addoption('8', "Miscellaneous")
  pmenu = popuplib.easymenu('pmenu', '_popup_choice', weapon_select)
  pmenu.settitle("Pistols:")
  smgmenu = popuplib.easymenu('smgmenu', '_popup_choice', weapon_select)
  smgmenu.settitle("Sub-Machine Guns:")
  smenu = popuplib.easymenu('smenu', '_popup_choice', weapon_select)
  smenu.settitle("Shotguns:")
  rmenu = popuplib.easymenu('rmenu', '_popup_choice', weapon_select)
  rmenu.settitle("Rifles:")
  mgmenu = popuplib.easymenu('mgmenu', '_popup_choice', weapon_select)
  mgmenu.settitle("Machine Guns:")
  srmenu = popuplib.easymenu('srmenu', '_popup_choice', weapon_select)
  srmenu.settitle("Sniper Rifles:")
  gmenu = popuplib.easymenu('gmenu', '_popup_choice', weapon_select)
  gmenu.settitle("Grenades:")
  mmenu = popuplib.easymenu('mmenu', '_popup_choice', weapon_select)
  mmenu.settitle("Miscellaneous:")
  for items in itemList:
    if not es.exists('clientcommand', 'buy_%s'%items):
      es.regclientcmd('buy_%s'%items, 'undead_buy/buy_client_cmd')
    if items in ['glock','usp','p228','deagle','fiveseven','elite']:
      pmenu.addoption(items, '%s ($%s)'%(items, int(itemList[items])))
    elif items in ['mac10','tmp','mp5','ump','p90']:
      smgmenu.addoption(items, '%s ($%s)'%(items, int(itemList[items])))
    elif items in ['m3','xm1014']:
      smenu.addoption(items, '%s ($%s)'%(items, int(itemList[items])))
    elif items in ['galil','famas','ak47','m4a1','sg552','aug']:
      rmenu.addoption(items, '%s ($%s)'%(items, int(itemList[items])))
    elif items in ['m249']:
      mgmenu.addoption(items, '%s ($%s)'%(items, int(itemList[items])))
    elif items in ['scout','g3sg1','sg550','awp']:
      srmenu.addoption(items, '%s ($%s)'%(items, int(itemList[items])))
    elif items in ['flashbang','smokegrenade','hegrenade']:
      gmenu.addoption(items, '%s ($%s)'%(items, int(itemList[items])))
    elif items in ['kevlar','assaultsuit','nvgs','defuser']:
      mmenu.addoption(items, '%s ($%s)'%(items, int(itemList[items])))
  if nadelimit > '0':
    for userid in es.getUseridList():
      if userid not in dictNades:
        dictNades[userid] = {}
        dictNades[userid]["hegrenade"] = 0
        dictNades[userid]["smokegrenade"] = 0
        dictNades[userid]["flashbang"] = 0
  es.msg('#multi', '#default[#greenUndead Buy#default] by #lightgreenUndead #defaulthas been loaded!')

def unload():
  if es.exists('saycommand', buy_cmd):
    es.unregsaycmd(buy_cmd)
  for items in itemList:
    if es.exists('clientcommand', 'buy_%s'%items):
      es.unregclientcmd('buy_%s'%items)
  popuplib.delete('bmenu')
  popuplib.delete('pmenu')
  popuplib.delete('smgmenu')
  popuplib.delete('smenu')
  popuplib.delete('rmenu')
  popuplib.delete('mgmenu')
  popuplib.delete('srmenu')
  popuplib.delete('gmenu')
  popuplib.delete('mmenu')
  if anytime == '0':
    gamethread.cancelDelayed('disableBuy')
  es.msg('#multi', '#default[#greenUndead Buy#default] by #lightgreenUndead #defaulthas been unloaded!')

def player_spawn(ev):
  userid = ev['userid']
  if nadelimit > '0':
    if userid not in dictNades:
      dictNades[userid] = {}
      dictNades[userid]["hegrenade"] = 0
      dictNades[userid]["smokegrenade"] = 0
      dictNades[userid]["flashbang"] = 0

def player_disconnect(ev):
  userid = ev['userid']
  if nadelimit > '0':
    if userid in dictNades:
      del dictNades[userid]

def round_start(ev):
  global buyAllowed
  if anytime == '0':
    buyAllowed = True
    gamethread.delayedname(float(es.ServerVar('mp_buytime')) * 60, 'disableBuy', disableBuy)

def round_end(ev):
  if anytime == '0':
    gamethread.cancelDelayed('disableBuy')

def disableBuy():
  global buyAllowed
  buyAllowed = False
  for player in es.getUseridList():
    if popuplib.isqueued('bmenu', player):
      popuplib.unsendname('bmenu', player)
      es.tell(player, 'It is too late to buy anything!')

def anyteam_check(userid):
  if anyteam == '0':
    return True
  elif anyteam == '1':
    if es.getplayerteam(userid) == 2:
      return True
  elif anyteam == '2':
    if es.getplayerteam(userid) == 3:
      return True

def buy_cmd_reg():
  userid = es.getcmduserid()
  if anyteam_check(userid):
    if playerlib.getPlayer(userid).inBuyZone() or anywhere == '1':
      if buyAllowed or anytime == '1':
        popuplib.send('bmenu', userid)
      else:
        es.tell(userid, 'It is too late to buy anything!')
    else:
      es.tell(userid, 'You must be in a Buy Zone to use this command.')
  else:
    es.tell(userid, 'You can not use this command on this team.')

def buy_client_cmd():
  userid = es.getcmduserid()
  if anyteam_check(userid):
    if playerlib.getPlayer(userid).inBuyZone() or anywhere == '1':
      if buyAllowed or anytime == '1':
        item = es.getargv(0).strip('buy_')
        if item in itemList:
           price = itemList[item]
           cash_check(userid, price, item)
        else:
          es.tell('Invalid Command or Item Doesn\'t Exists')
      else:
        es.tell(userid, 'It is too late to buy anything!')
    else:
      es.tell(userid, 'You must be in a Buy Zone to use this command.')
  else:
    es.tell(userid, 'You can not use this command on this team.')
 
def cash_check(userid, price, item):
  player = playerlib.getPlayer(userid)
  if player.cash < price:
    es.tell(userid, 'Not enough cash!')
  else:
    player.cash -= price
    es.tell(userid, 'Transaction Successful!')
    if item not in ['kevlar','assaultsuit','nvgs','defuser']:
      if item in ['hegrenade','flashbang','smokegrenade']:
        dictNades[userid][item] += 1
        if dictNades[userid][item] > nadelimit:
          es.tell(userid, 'You have maxed out your allowed number of %s\'s.'%item)
          return
      es.server.queuecmd('es_xgive %s weapon_%s'%(userid, item))
    else:
      es.server.queuecmd('es_xgive %s item_%s'%(userid, item))

def bmenu_select(userid, choice, popupid):
  if playerlib.getPlayer(userid).inBuyZone():
    if choice == '1':
      popuplib.send('pmenu', userid)
    elif choice == '2':
      popuplib.send('smgmenu', userid)
    elif choice == '3':
      popuplib.send('smenu', userid)
    elif choice == '4':
      popuplib.send('rmenu', userid)
    elif choice == '5':
      popuplib.send('mgmenu', userid)
    elif choice == '6':
      popuplib.send('srmenu', userid)
    elif choice == '7':
      popuplib.send('gmenu', userid)
    elif choice == '8':
      popuplib.send('mmenu', userid)
  else:
    es.tell(userid, 'You must be in a Buy Zone to buy anything!')

def weapon_select(userid, choice, popupid):
  cash_check(userid, int(itemList[choice]), choice)